#ifndef SA_Problem_H
#define SA_Problem_H

#include <iostream.h>
#include "Array.hh"


class SA_Problem;


class SA_Solution
{
	friend SA_Problem;

	public:
		int n;
	  	Array<int> phi;
		int i,j;
		int oldcost;
		int newcost;

		SA_Solution (); 
   		void Copy (SA_Solution & source);
		friend ostream& operator<< (ostream&, SA_Solution&);
};


class SA_Move 
{ 
   friend SA_Problem;

   public: 
	   	SA_Move ();
   		SA_Move (SA_Problem&);
   		~SA_Move ();
		friend ostream & operator<< (ostream&, SA_Move&);
};



class SA_Problem
{

	public:
		int n,m;
		Array<int> deg,adj,edg;
		float localn,globaln;
		
		SA_Problem();
		~SA_Problem();

		void EvaluateOptions (int* argc,char* **argv);
		int	ReadProblemData (char*);
		SA_Solution* CreateSolution ();
		void GetInitialSolution (SA_Solution&);
		void GetRandomSolution (SA_Solution&);
		float GetCost (SA_Solution&); 
		void GetNeighbor (SA_Solution&, float rel_temp);
		void ResetSolution (SA_Solution&);
		void UpdateSolution (SA_Solution&);
		float GetLocalN ();
		float GetGlobalN ();	
		void Copy (SA_Solution& source, SA_Solution& dest);		
		void OutputSolution (ostream&, SA_Solution&);
		int	InputSolution (istream&, SA_Solution&);
		SA_Move* CreateMove ();
		int	ExtractMove (SA_Solution&, SA_Move&); 
	  	int ApplyMove (SA_Solution&, SA_Move&);
		void OutputMove (ostream&, SA_Move&);
		int	InputApplyMoves (istream&, SA_Solution&);
		int	OutputSolution (char* filename, SA_Solution& sol);
		int	InputSolution (char* filename, SA_Solution& sol);
		void Postprocessing (SA_Solution&);
		int	Reoptimize (SA_Solution&);
		void ControlOutput (ostream& out = cout);
};


#endif

